'use strict';
const{classes:Cc,interfaces:Ci,utils:Cu}=Components;
Cu.import('resource://gre/modules/Services.jsm');
Cu.import('resource://gre/modules/FileUtils.jsm');
Cu.import('resource://gre/modules/NetUtil.jsm');
let URLFilter={
get:function(key){return(key in this.data)?this.data[key]:null},
put:function(key,value){this.values++;this.data[key]=value},
clear:function(){this.values=0;this.data={}},

init:function(){
	this.clear();
	this._branch=Services.prefs.getBranch('extensions.urlfilter.');
	if(!('addObserver' in this._branch))
		this._branch.QueryInterface(Ci.nsIPrefBranch2);
	this.nsISupportsString=Cc['@mozilla.org/supports-string;1'].createInstance(Ci.nsISupportsString);
	this.ini=this.getPref('ini','https://raw.githubusercontent.com/temnikov/urlfilter/master/urlfilter.ini');
	this.css=this.getPref('css','https://raw.githubusercontent.com/temnikov/urlfilter/master/urlfilter.css');
	this.ap=this.getPref('ap','https://raw.githubusercontent.com/temnikov/urlfilter/master/urlfilter_ap.ini');
	this.updateday=this.getPref('updateday',3);
	this.updatetime=this.getPref('updatetime',0);
	this.safesites=this.getPref('safesites',true);
	if(this.safesites){
		Cc['@mozilla.org/cookiemanager;1'].getService(Ci.nsICookieManager2).add('.youtube.com','/','PREF','f2=8000000&f1=50000000',false,false,false,'1687465999');
		Cc['@mozilla.org/cookiemanager;1'].getService(Ci.nsICookieManager2).add('.vimeo.com','/','content_rating','7',false,false,false,'1687465999');
		Cc['@mozilla.org/cookiemanager;1'].getService(Ci.nsICookieManager2).add('.sputnik.ru','/','famlev','r1',false,false,false,'1687465999');
	}
	this.youtubehtml5=this.getPref('youtubehtml5',true);
	this.debug=this.getPref('debug',false);
	this._branch.addObserver('',this,false);

	this.converter=Cc['@mozilla.org/intl/scriptableunicodeconverter'].createInstance(Ci.nsIScriptableUnicodeConverter);
	this.converter.charset='UTF-8';
	let update=((((Date.now()/1000)-this.updatetime)/86400)>this.updateday)?true:false,
	inifile=FileUtils.getFile('ProfD',[(this.ini==='in_profile')?'urlfilter.ini':'urlfilter_loaded.ini']),
	cssfile=FileUtils.getFile('ProfD',[(this.css==='in_profile')?'urlfilter.css':'urlfilter_loaded.css']),
	apfile=FileUtils.getFile('ProfD',['urlfilter_ap.ini']);
	this.http_regexp=this.tmp_regexp='';
	this.ini_readed=this.ap_readed=false;

	if(update){
		this.Regexp=new RegExp('\r');
		if(this.ini!=='not_use')
			(this.ini!=='in_profile')?this.load_file(this.ini,inifile,'ini'):this.parse_file(inifile.path,inifile,'ini');
		if(this.ap!=='not_use')
			this.load_file(this.ap,apfile,'ap');
		if(this.css!=='not_use')
			(this.css!=='in_profile')?this.load_file(this.css,cssfile,'css'):this.parse_file(cssfile.path,cssfile,'css');
	}else{
		if(this.css!=='not_use')
			(this.css!=='in_profile')?this.parse_file(this.css,cssfile,'css'):this.parse_file(cssfile.path,cssfile,'css');
		try{
			this.Regexp=new RegExp(this.getPref('regexp','\r'));
		}catch(e){
			Services.console.logStringMessage('URLFilter: Error making Regexp: '+this.Regexp);
			this._branch.setIntPref('updatetime',0);
			this.Regexp=new RegExp('\r');
		}
	}
	Services.obs.addObserver(this,'http-on-modify-request',false);
	Services.obs.addObserver(this,'addon-options-displayed',false);
	Services.obs.addObserver(this,'idle-daily',false);
},

make_regexp:function(){
if((this.ini_readed&&this.ap_readed)||((this.ini==='not_use')&&this.ap_readed)||(this.ini_readed&&(this.ap==='not_use'))){
	if(this.tmp_regexp!=='')this.tmp_regexp=this.optimize_regexp(this.tmp_regexp,false).replace(/\xA9/g,'|');
	if(this.http_regexp!=='')this.http_regexp=this.optimize_regexp(this.http_regexp,false).replace(/\xA9/g,'|');
//https?://([a-z\d._-]*\.)?(?:$http_regexp)
//(?:tmp_regexp)
//(?:(?:tmp_regexp)|https?://([a-z\d._-]*\.)?(?:$http_regexp))
	this.Regexp=(this.tmp_regexp==='')?'https?://([a-z\\d._-]*\\.)?(?:'+this.http_regexp.replace(/\|$/,'')+')'
	:(this.http_regexp==='')?'(?:'+this.tmp_regexp.replace(/\|$/,'')+')'
	:'(?:(?:'+this.tmp_regexp.replace(/\|$/,'')+')|https?://([a-z\\d._-]*\\.)?(?:'+this.http_regexp.replace(/\|$/,'')+'))';
	try{
		this.nsISupportsString.data=this.Regexp;
		this._branch.setComplexValue('regexp',Ci.nsISupportsString,this.nsISupportsString);
		this.Regexp=new RegExp(this.Regexp);
		this._branch.setIntPref('updatetime',parseInt(Date.now()/1000));
		this.http_regexp=this.tmp_regexp='';
	}catch(e){
		Services.console.logStringMessage('URLFilter: Error making Regexp: '+this.Regexp);
		this._branch.setIntPref('updatetime',0);
		this.Regexp=new RegExp('\r');
	}
}
},

parse_file:function(url,file,text){
if(text==='ini'){
	NetUtil.asyncFetch(file,function(inputStream,status){
	if(!Components.isSuccessCode(status)){
		URLFilter._branch.setIntPref('updatetime',0);
		Services.console.logStringMessage('URLFilter: Error parsing ini file: '+file.path);
		URLFilter.load_file(url,file,'ini');
		URLFilter.ini_readed=true;
		URLFilter.make_regexp();
		return;
	}
	let Array=URLFilter.converter.ConvertToUnicode(NetUtil.readInputStreamToString(inputStream,inputStream.available())).split(/[\r\n]+/),i=0,flag=false,tmp_regexp='',http_regexp='';
	while(i!==Array.length){
		if(flag&&(Array[i]!=='')&&(!/^;/.test(Array[i]))){
			Array[i]=Array[i].replace(/(.*[^\*]$)/,'$1$')
			.replace(/\*$/,'')		.replace(/\./g,'\\.')
			.replace(/\*/g,'\.\*')		.replace(/\+/g,'\\+')
			.replace(/\?/g,'\\?')		.replace(/\|\.\*\|/g,'\.\*')
			.replace(/\|/g,'\xA9')		.replace(/\(\\\?\!/g,'(?!')
			.replace(/\(\\\?\=/g,'(?=')	.replace(/\(\\\?\:/g,'(?:');
			if(/^https\:\/\/www\.fanboy\./.test(URLFilter.ini))
				Array[i]=Array[i].replace(/^\.\*\:\/\/.*/,'');
			if(/^https?:\/\//.test(Array[i]))
				http_regexp+=Array[i].replace(/https?:\/\/(www\.)?/,'')+'|';
			else if(/^\.\*\\\.[^\/]*\.[a-z]{2,4}\/$/.test(Array[i]))
				http_regexp+=Array[i].replace(/^\.\*\\\.([^\/]*\.[a-z]{2,4}\/)$/,'$1')+'|';
			else tmp_regexp+=Array[i]+'|';
		}else if(/\[exclude\]/.test(Array[i]))flag=true;
		i++;
	};
	URLFilter.http_regexp+=http_regexp;
	URLFilter.tmp_regexp=tmp_regexp;
	URLFilter.ini_readed=true;
	URLFilter.make_regexp();
	});
}else if(text==='ap'){
	NetUtil.asyncFetch(file,function(inputStream,status){
	if(!Components.isSuccessCode(status)){
		URLFilter._branch.setIntPref('updatetime',0);
		Services.console.logStringMessage('URLFilter: Error parsing ap file: '+file.path);
		URLFilter.load_file(url,file,'ap');
		URLFilter.ap_readed=true;
		URLFilter.make_regexp();
		return;
	}
	let Array=URLFilter.converter.ConvertToUnicode(NetUtil.readInputStreamToString(inputStream,inputStream.available())).split(/[\r\n]+/),i=0,http_regexp='';
	while(i!==Array.length){
		if((Array[i]!=='')&&(!/^;/.test(Array[i])))http_regexp+=Array[i].replace(/\./g,'\\.')
			.replace(/\*/g,'\.\*')		.replace(/\+/g,'\\+')
			.replace(/\?/g,'\\?')		.replace(/\|/g,'\xA9')
			.replace(/\(\\\?\!/g,'(?!')	.replace(/\(\\\?\=/g,'(?=')
			.replace(/\(\\\?\:/g,'(?:')	.replace(/^\.\*(.*)/,'\*\*$1')+'|';
		i++;
	};
	URLFilter.http_regexp+=http_regexp;
	URLFilter.ap_readed=true;
	URLFilter.make_regexp();
	});
}else if(text==='css'){
	NetUtil.asyncFetch(file,function(inputStream,status){
	if(!Components.isSuccessCode(status)){
		URLFilter._branch.setIntPref('updatetime',0);
		Services.console.logStringMessage('URLFilter: Error parsing css file: '+file.path);
		URLFilter.load_file(url,file,'css');
		return;
	}
	URLFilter.styleService=Cc['@mozilla.org/content/style-sheet-service;1'].getService(Ci.nsIStyleSheetService);
	if(URLFilter.url){
		URLFilter.styleService.unregisterSheet(URLFilter.url,URLFilter.styleService.USER_SHEET);
		URLFilter.url=null;
	}
	let cssData=URLFilter.converter.ConvertToUnicode(NetUtil.readInputStreamToString(inputStream,inputStream.available()));
	if(cssData){
		URLFilter.url=Cc['@mozilla.org/network/simple-uri;1'].createInstance(Ci.nsIURI);
		URLFilter.url.spec='data:text/css;charset=utf8,'+encodeURIComponent('\n'+cssData);
		URLFilter.styleService.loadAndRegisterSheet(URLFilter.url,URLFilter.styleService.USER_SHEET);
	}
	});
}
},

observe:function(aSubject,aTopic,aData){
	if(aTopic==='http-on-modify-request'){
		aSubject.QueryInterface(Ci.nsIHttpChannel);
		if(this.check_URL(aSubject.URI.spec)){
			aSubject.cancel(Components.results.NS_ERROR_FAILURE);
			if(this.debug)Services.console.logStringMessage('URLFilter == '+aSubject.URI.spec);
			return;
		}
		if(this.debug)Services.console.logStringMessage('URLFilter != '+aSubject.URI.spec);
		if(this.youtubehtml5&&(/[./]youtube\.com\/(embed|v)\//.test(aSubject.URI.spec)))
			try{aSubject.URI.spec=aSubject.URI.spec.replace(/\/v\//,"/embed/")+'?html5=1';}catch(e){}
		if(!this.safesites)return;
		if(/[./]google\.\w{2,3}\/(?:s|search|complete\/search)\?/.test(aSubject.URI.spec))
			aSubject.URI.spec=aSubject.URI.spec+'&safe=strict';
		else if(/[./]bing\.com\/(?:qsonhs\.aspx|search|images\/search|videos\/search)/.test(aSubject.URI.spec))
			aSubject.URI.spec=aSubject.URI.spec+'&adlt=strict';
		else if(/[./]yahoo\.com\/(?:search|gossip)/.test(aSubject.URI.spec))
			aSubject.URI.spec=aSubject.URI.spec.replace(/\&vm=p/,'')+'&vm=r';
		else if(/[./]yandex\.\w{2,3}\/(?:search|images\/search|yandsearch|jclck|suggest)/.test(aSubject.URI.spec))
			aSubject.URI.spec=aSubject.URI.spec+'&family=1';
		else if(/[./]nova\.rambler\.ru\/(?:video|suggest)/.test(aSubject.URI.spec))
			aSubject.URI.spec=aSubject.URI.spec.replace(/\&filter=off$/,'')+'&filter=on';
		else if(/[./]images\.rambler\.ru\/(?:\?query=|cl|search|suggest)/.test(aSubject.URI.spec))
			aSubject.URI.spec=aSubject.URI.spec.replace(/\&adult=$/,'')+'&adult=on';
		else if(/[./]rambler\.ru\/(?:\?query=|search|video|cl|suggest)/.test(aSubject.URI.spec))
			aSubject.URI.spec=aSubject.URI.spec+'&adult=family';
		else if(/[./]mail\.ru\/(?:search|sg_u|search_images|sg_images_u|search_video|sg_video_u)/.test(aSubject.URI.spec))
			aSubject.URI.spec=aSubject.URI.spec+'&fs=1';
		else if(/[./]qip\.ru\/search/.test(aSubject.URI.spec))
			aSubject.URI.spec=aSubject.URI.spec+'&ad=1&filtr=strict';
		else if(/[./]video.qip\.ru\/\?query=/.test(aSubject.URI.spec))
			aSubject.URI.spec=aSubject.URI.spec+'&ad=1&filtr=strict';
		else if(/[./]youtube\.com\//.test(aSubject.URI.spec))
			Cc['@mozilla.org/cookiemanager;1'].getService(Ci.nsICookieManager2).add('.youtube.com','/','PREF','f2=8000000&f1=50000000',false,false,false,'1687465999');
		else if(/[./]sputnik\.ru\//.test(aSubject.URI.spec))
			Cc['@mozilla.org/cookiemanager;1'].getService(Ci.nsICookieManager2).add('.sputnik.ru','/','famlev','r1',false,false,false,'1687465999');
		else if(/[./]vimeo\.com\//.test(aSubject.URI.spec))
			Cc['@mozilla.org/cookiemanager;1'].getService(Ci.nsICookieManager2).add('.vimeo.com','/','content_rating','7',false,false,false,'1687465999');
	}else if(aTopic==='nsPref:changed'){
		switch(aData){
		case 'safesites':
			this.safesites=this._branch.getBoolPref('safesites');
			break;
		case 'youtubehtml5':
			this.youtubehtml5=this._branch.getBoolPref('youtubehtml5');
			break;
		case 'debug':
			this.debug=this._branch.getBoolPref('debug');
			break;
		case 'update':
		case 'ini':
		case 'ap':
		case 'css':
			if(this.getPref('update',false)){
				this.uninit();
				this._branch.setIntPref('updatetime',0);
				this._branch.setBoolPref('update',false);
				this.init();
			}
			break;
		}
	}else if(aTopic==='idle-daily'){
		if((((Date.now()/1000)-this.updatetime)/86400)>this.updateday){
			this.uninit();
			this.init();
		}
	}
},

check_URL:function(url){
	switch(this.get(url)){
	case null:
		if(this.Regexp.test(url)){
			this.put(url,true);
			return true;
		};
		this.put(url,false);
		return false;
	case false:
		return false;
	case true:
		if(this.values>2000)this.clear();
		return true;
	}
},

load_file:function(url,file,text){
try{
	let req=Cc['@mozilla.org/xmlextras/xmlhttprequest;1'].createInstance(Ci.nsIXMLHttpRequest);
	req.open('GET',url,true);
	req.onreadystatechange=function(aEvt){
		if((req.readyState==4)&&(req.status==200))
			NetUtil.asyncCopy(
				URLFilter.converter.convertToInputStream(req.responseText),
				FileUtils.openSafeFileOutputStream(file),
				function(status){
					URLFilter._branch.setIntPref('updatetime',parseInt(Date.now()/1000));
					URLFilter.parse_file(url,file,text);
				}
			);
	};
	req.send(null);
}catch(e){
	URLFilter._branch.setIntPref('updatetime',0);
	Services.console.logStringMessage('URLFilter: Error loading '+text+' file: '+url);
}
},

optimize_regexp:function(line,again){
	let all='',ap='',al='',po='',pp='',sl='',qu='',ot='',ar=line.split('|'),map={},str,chr;
	for(let i=0;i<ar.length;i++){
		str=ar[i];chr=str[0];
		if(/(?:\w|\d|-|:|&)/.test(chr))
			if(chr in map)
				map[chr].push(str.substr(1))
			else
				map[chr]=[str.substr(1)];
		else{
			if(/^\*\*/.test(ar[i]))ap+=ar[i].replace(/^\*\*(.*)/,'$1')+'|'
			else if(/^\.\*/.test(ar[i]))al+=ar[i].replace(/^\.\*(.*)/,'$1')+'|'
			else if(/^\\\./.test(ar[i]))po+=ar[i].replace(/^\\\./,'')+'|'
			else if(/^_/.test(ar[i]))pp+=ar[i].replace(/^_/,'')+'|'
			else if(/^\//.test(ar[i]))sl+=ar[i].replace(/^\//,'')+'|'
			else if(/^\\\?/.test(ar[i]))qu+=ar[i].replace(/^\\\?/,'')+'|'
			else ot+=ar[i]+'|';
		}
	}

	for(let key in map)
		if(key!=='undefined'){
			str=map[key];
			if(str.length===1)
				all+=key+str+'|';
			else{
				chr=str.join('|');
				if(!again)chr=this.optimize_regexp(chr,true);
				all+=key+'(?:'+chr.replace(/\|$/,'')+')|';
			}
		}

	if(pp!=='')all+='_(?:'+this.optimize_regexp(pp,true).replace(/\|$/,'')+')|';
	if(sl!=='')all+='/(?:'+this.optimize_regexp(sl,true).replace(/\|$/,'')+')|';
	if(po!=='')all+='\\\.(?:'+this.optimize_regexp(po,true).replace(/\|$/,'')+')|';
	if(qu!=='')all+='\\\?(?:'+this.optimize_regexp(qu,true).replace(/\|$/,'')+')|';
	if(ap!=='')all+='[a-z\\d._-]*(?:'+this.optimize_regexp(ap,true).replace(/\|$/,'')+').*/|';
	if(al!=='')all+='.*(?:'+this.optimize_regexp(al,true).replace(/\|$/,'')+')|';
	if(ot!=='')all+='(?:'+ot.replace(/\|$/,'')+')|';
	return all;
},

uninit:function(){
	Services.obs.removeObserver(this,'idle-daily');
	Services.obs.removeObserver(this,'addon-options-displayed');
	Services.obs.removeObserver(this,'http-on-modify-request');
	this._branch.removeObserver('',this);
	if(this.url){
		this.styleService.unregisterSheet(this.url,this.styleService.USER_SHEET);
		this.url=null;
	}
},

getPref:function(key,def){
	switch(typeof def){
	case 'boolean':
		try{this._branch.getBoolPref(key)}
		catch(e){this._branch.setBoolPref(key,def)}
		return this._branch.getBoolPref(key);
	case 'number':
		try{this._branch.getIntPref(key)}
		catch(e){this._branch.setIntPref(key,def)}
		return this._branch.getIntPref(key);
	case 'string':
		try{this._branch.getComplexValue(key,Ci.nsISupportsString).data}
		catch(e){
			this.nsISupportsString.data=def;
			this._branch.setComplexValue(key,Ci.nsISupportsString,this.nsISupportsString);
		}
		return this._branch.getComplexValue(key,Ci.nsISupportsString).data;
	}
},

locale:function(s){
	return(this.bundle)?this.bundle.GetStringFromName(s):s;
},

button:function(window){
	if(!window||!window.getBrowser)return;

	let button=window.document.getElementById('urlfilter-tbutton');
	if(button)return;

	this.bundle=Cc['@mozilla.org/intl/stringbundle;1'].getService(Ci.nsIStringBundleService)
		.createBundle('chrome://urlfilter/locale/strings.properties');

	let menu=window.document.getElementById('urlfilter-context-menu');
	if(menu)menu.parentNode.removeChild(menu);

	button=window.document.createElement('toolbarbutton');
	button.setAttribute('id','urlfilter-tbutton');
	button.setAttribute('label','URLFilter');
	button.setAttribute('tooltiptext','URLFilter');
	button.setAttribute('class','toolbarbutton-1 chromeclass-toolbar-additional');
	button.setAttribute('image','chrome://global/skin/icons/blacklist_favicon.png');
	button.setAttribute('style','opacity:.7 !important;');
	button.setAttribute('removable','true');
	button.setAttribute('context','urlfilter-context-menu');
	button.addEventListener('click',function(event){
		if(event.button===2)return;
		let toggle_button=function(button){
			if(!button)return;
			if(button.off){
				if(event.button===1){
					URLFilter.uninit();
					URLFilter._branch.setIntPref('updatetime',0);
				}else{
					button.setAttribute('style','opacity:.7 !important;');
					button.off=false;
					URLFilter.init();
				}
			}else{
				URLFilter.uninit();
				if(event.button===1){
					URLFilter._branch.setIntPref('updatetime',0);
					URLFilter.init();
				}else{
					button.setAttribute('style','opacity:.2 !important;');
					button.off=true;
				}
			}
		};
		if(URLFilter.thunderbird)
			toggle_button(window.document.getElementById('urlfilter-tbutton'));
		else{
			let enumerator=Cc['@mozilla.org/appshell/window-mediator;1'].getService(Ci.nsIWindowMediator).getEnumerator('navigator:browser');
			while(enumerator.hasMoreElements())
				toggle_button(enumerator.getNext().QueryInterface(Ci.nsIDOMWindow).document.getElementById('urlfilter-tbutton'));
		}
	},false);

	if(URLFilter.thunderbird)
		this.addTbuttonTB(window,button)
	else
		this.addTbutton(window,button);

	let p=window.document.getElementById('mainPopupSet');
	if(!p)return;
	menu=window.document.createElement('menupopup');
	menu.setAttribute('id','urlfilter-context-menu');
	let e=window.document.createElement('menuitem');
	e.setAttribute('label',this.locale('UpdateNow'));
	e.addEventListener('command',function(event){
		URLFilter.uninit();
		URLFilter._branch.setIntPref('updatetime',0);
		if(URLFilter.thunderbird){
			let button=window.document.getElementById('urlfilter-tbutton');
			if(button&&!button.off)URLFilter.init();
		}else{
			let enumerator=Cc['@mozilla.org/appshell/window-mediator;1'].getService(Ci.nsIWindowMediator).getEnumerator('navigator:browser');
			while(enumerator.hasMoreElements()){
				let button=enumerator.getNext().QueryInterface(Ci.nsIDOMWindow).document.getElementById('urlfilter-tbutton');
				if(button&&!button.off)URLFilter.init();
			}
		}
	},false);
	menu.appendChild(e);
	e=window.document.createElement('menuseparator');
	e.setAttribute('id','urlfilter-menu-sep');
	menu.appendChild(e);
	e=window.document.createElement('menuitem');
	e.setAttribute('label',this.locale('Donate'));
	e.addEventListener('command',function(event){
		let url='http://addons.mozilla.org/firefox/addon/urlfilter/';
		if(URLFilter.thunderbird){
			let tabmail=window.document.getElementById('tabmail');
			if(!tabmail&&window)tabmail=Services.wm.getMostRecentWindow('mail:3pane').document.getElementById('tabmail');
			if(tabmail)
				tabmail.openTab('contentTab',{contentPage:url})
			else
				window.openDialog('chrome://messenger/content/','_blank','chrome,dialog=no,all',null,{tabType:'contentTab',tabParams:{contentPage:url}});
		}else{
			let win=Cc['@mozilla.org/appshell/window-mediator;1'].getService(Ci.nsIWindowMediator).getMostRecentWindow('navigator:browser');
			if(win)
				win.gBrowser.loadOneTab(url,null,null,null,false,false)
			else
				window.open(url);
		}
	},false);
	menu.appendChild(e);
	p.appendChild(menu);
},

addTbutton:function(window,em){
	let ar=window.document.getElementsByTagName('toolbar'),list;
	for(let i=0;i<ar.length;i++){
		list=ar[i].getAttribute('currentset').split(',');
		for(let j=0;j<list.length;j++)
			if(list[j]===em.id){
				ar[i].insertBefore(em,ar[i].childNodes[j]);
				return;
			}
	}
	let tb=window.document.getElementById('navigator-toolbox');
	if(tb)tb.palette.appendChild(em);
},

addTbuttonTB:function(window,button){
	window.document.getElementById('mail-toolbox').palette.appendChild(button);
	let toolbars=window.document.querySelectorAll('toolbar[currentset*='+button.id+']'),currentset,pos,sib,offset,sel;
	for(let i=0;i<toolbars.length;i++){
		currentset=toolbars[i].getAttribute('currentset').split(',');
		pos=currentset.indexOf(''+button.id);
		if(pos===-1)continue;
		sib=null;
		offset=0;
		while(pos<currentset.length-1){
			pos++;
			switch(currentset[pos]){
				case 'separator':
				case 'spring':
				case 'spacer':
					offset++;
					continue;
			};
			sel='#'+currentset[pos];
			sib=toolbars[i].querySelector(sel);
			if(sib)break;
		}
		if(!sib&&offset){
			sib=toolbars[i].lastChild;
			offset--;
		}
		while(sib&&offset--)
			sib=sib.previousSibling;
		toolbars[i].insertItem(''+button.id,sib);
	}
},

delTbutton:function(win,id){
try{
	let n=win.document.getElementById('urlfilter-tbutton');
	if(n)n.parentNode.removeChild(n);
	n=win.document.getElementById('urlfilter-context-menu');
	if(n)n.parentNode.removeChild(n);
	n=win.document.getElementById(id).palette;
	for(let i=0;i<n.childElementCount;i++)
		if(n.childNodes[i].id==='urlfilter-tbutton')
			n.removeChild(n.childNodes[i]);
}catch(e){};
},

handleEvent:function(e){
	let win=e.target.defaultView;
	win.removeEventListener('load',this,false);
	this.button(win);
},
onOpenWindow:function(aWindow){
 	let win=aWindow.QueryInterface(Ci.nsIInterfaceRequestor).getInterface(Ci.nsIDOMWindowInternal||Ci.nsIDOMWindow);
	win.addEventListener('load',this,false);
},
onCloseWindow:function(aWindow){},
onWindowTitleChange:function(aWindow,aTitle){}
};

function startup(data,reason){
	URLFilter.init();
	let wm=Services.wm;
	URLFilter.thunderbird=(Cc['@mozilla.org/xre/app-info;1'].getService(Ci.nsIXULAppInfo).name==='Thunderbird')?true:false;
	if(URLFilter.thunderbird)
		URLFilter.button(wm.getMostRecentWindow('mail:3pane'));
	else{
		let enumerator=wm.getEnumerator('navigator:browser');
		while(enumerator.hasMoreElements())
			URLFilter.button(enumerator.getNext().QueryInterface(Ci.nsIDOMWindow));
	}
	wm.addListener(URLFilter);
}
function shutdown(data,reason){
	URLFilter.uninit();
	let wm=Services.wm;
	if(URLFilter.thunderbird)
		URLFilter.delTbutton(wm.getMostRecentWindow('mail:3pane'),'mail-toolbox');
	else{
		let enumerator=wm.getEnumerator('navigator:browser');
		while(enumerator.hasMoreElements()){
			let win=enumerator.getNext().QueryInterface(Ci.nsIDOMWindow);
			if(win)URLFilter.delTbutton(win,'navigator-toolbox');
		}
	}
	wm.removeListener(URLFilter);
}
function install(data,reason){}
function uninstall(data,reason){
if(reason<7){
	Services.prefs.deleteBranch('extensions.urlfilter.');
	FileUtils.getFile('ProfD',['urlfilter_loaded.ini']).remove(false);
	FileUtils.getFile('ProfD',['urlfilter_loaded.css']).remove(false);
	FileUtils.getFile('ProfD',['urlfilter_ap.ini']).remove(false);
}
}
